# minsys.rb -- MINSYS file generation routines
#
# Written 010810 by Mirian Crzig Lennox
# Copyright (c) 2001, released under the terms of the GNU Public License

require "pdp10"
require "dumper"
require "evac"

include PDP10

class Minsys < File
  include PDP10::Dumper

  def initialize fn
    super(fn, "w")
    create_tape_header 1
  end

  def close
    write_mark
    super
  end

  def minfile(dir, fn1, fn2, unixfn)
    if File.exists? unixfn
      $stdout.printf "dumping %s as %s; %s %s\n", unixfn, dir, fn1, fn2
      unixf = File.open unixfn
      class <<unixf
	include PDP10::Evac
      end
      buftime = unixf.stat.ctime
      buf = unixf.read_buffer
      unixf.close
      dump_file buf, dir, fn1, fn2, buftime
    else
      $stderr.printf "%s; %s %s - %s does not exist\n", dir,fn1,fn2,unixfn
    end
  end

  def minlink(dir, fn1, fn2, sdir, sfn1, sfn2)
    $stdout.printf("linking %s; %s %s to %s; %s %s\n",
    		   dir,fn1,fn2,sdir,sfn1,sfn2)
    dump_link(dir, fn1, fn2, Time.new, sdir, sfn1, sfn2)
  end
end
